#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>

#define MAXLINE 256

#define SOCKET "./server.socket"

int main(int argc, char **argv)
{
  int sockfd, num_read;
  char buffer[MAXLINE];
  struct sockaddr_un servaddr;
  
  /* creates socket stream domain UNIX */
  if ((sockfd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0){
    perror("socket error");
    exit(-1);
  }
  
  /* structure address cleaning */
  bzero(&servaddr, sizeof(servaddr));
  servaddr.sun_family = AF_UNIX;
  strcpy(servaddr.sun_path, SOCKET);
  
  /* initiate a connection on a socket */
  if (connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0){
    perror("connect error");
    exit(-1);
  }
  
  /* reads from stdin */
  num_read = read(0,buffer,MAXLINE);
  if (num_read <= 0) {
    perror("client, error reading from stdin.");
    exit(-1);
  }
  buffer[num_read-1] = '\0';

  /* writes to socket */
  if (write(sockfd, buffer, num_read) < 0)
    perror("write error");
  
  /* waits for an answer */
  if (read(sockfd, buffer, MAXLINE) < 0)
    perror("read error");

  printf("answer: %s\n", buffer);

  exit(0);
}
